//=============================================================================
//  BlueLeaf1336 http://www.geocities.jp/fjtkt/
//-----------------------------------------------------------------------------
//  2006.09.09  쐬
//  2006.09.10  TDatabaseJet.Open  mdb Ȃ΍쐬悤ɂ
//              TDatabaseJet.ChangePassword ǉ(s΍K)
//              TDatabaseJet.CompactDatabase ǉ
//  2006.09.13  TDatabaseJet.SyncNullableAllowZeroLength ǉ
//              TDatabaseJet.ColumnTypeIsText ǉ
//  2006.09.14  TDatabase.ReOpen ǉ
//=============================================================================

{
    Ql

    Collection.Count
    Collection.Item[i]
        Collection = Tables, Columns, Fields, Properties, etc.

    Table = Catalog.Tables[i]

        Table.Columns
        Table.Name
        Table.DateCreated
        Table.DateModified
        Table.Type

    Column = Table.Columns[i]

        Column.Name
        Column.Type
        Column.Attributes
        Column.DefinedSize
        Column.NumericScale
        Column.Precision

    Field = RecordSet.Fields[i]

        Column̑S
        Field.Value
        Field.ActualSize

    Object.Properties
        Object = Table, Column, Field, etc.

    Property = Object.Properties[i]
        Property.Name
        Property.Value
}

unit DatabaseIO;

interface

uses
    Windows, SysUtils, Classes, ComObj, Variants, SyncObjs;

//-----------------------------------------------------------------------------
//  unit ADODB_TLB
//  Type Lib: C:\Program Files\Common Files\System\ado\msado15.dll
//  DataTypeEnum
const
    adEmpty            =     0; //  Specifies no value (DBTYPE_EMPTY).
    adSmallInt         =     2; //  Indicates a two-byte signed integer (DBTYPE_I2).
    adInteger          =     3; //  Indicates a four-byte signed integer (DBTYPE_I4).
    adSingle           =     4; //  Indicates a single-precision floating-point value (DBTYPE_R4).
    adDouble           =     5; //  Indicates a double-precision floating-point value (DBTYPE_R8).
    adCurrency         =     6; //  Indicates a currency value (DBTYPE_CY). Currency is a fixed-point number with four digits to the right of the decimal point. It is stored in an eight-byte signed integer scaled by 10,000.
    adDate             =     7; //  Indicates a date value (DBTYPE_DATE). A date is stored as a double, the whole part of which is the number of days since December 30, 1899, and the fractional part of which is the fraction of a day.
    adBSTR             =     8; //  Indicates a null-terminated character string (Unicode) (DBTYPE_BSTR).
    adIDispatch        =     9; //  Indicates a pointer to an IDispatch interface on a COM object (DBTYPE_IDISPATCH).
                                //  This data type is currently not supported by ADO. Usage may cause unpredictable results.
    adError            =    10; //  Indicates a 32-bit error code (DBTYPE_ERROR).
    adBoolean          =    11; //  Indicates a boolean value (DBTYPE_BOOL).
    adVariant          =    12; //  Indicates an Automation Variant (DBTYPE_VARIANT).
                                //  This data type is currently not supported by ADO. Usage may cause unpredictable results.
    adIUnknown         =    13; //  Indicates a pointer to an IUnknown interface on a COM object (DBTYPE_IUNKNOWN).
                                //  This data type is currently not supported by ADO. Usage may cause unpredictable results.
    adDecimal          =    14; //  Indicates an exact numeric value with a fixed precision and scale (DBTYPE_DECIMAL).
    adTinyInt          =    16; //  Indicates a one-byte signed integer (DBTYPE_I1).
    adUnsignedTinyInt  =    17; //  Indicates a one-byte unsigned integer (DBTYPE_UI1).
    adUnsignedSmallInt =    18; //  Indicates a two-byte unsigned integer (DBTYPE_UI2).
    adUnsignedInt      =    19; //  Indicates a four-byte unsigned integer (DBTYPE_UI4).
    adBigInt           =    20; //  Indicates an eight-byte signed integer (DBTYPE_I8).
    adUnsignedBigInt   =    21; //  Indicates an eight-byte unsigned integer (DBTYPE_UI8).
    adFileTime         =    64; //  Indicates a 64-bit value representing the number of 100-nanosecond intervals since January 1, 1601 (DBTYPE_FILETIME).
    adGUID             =    72; //  Indicates a globally unique identifier (GUID) (DBTYPE_GUID).
    adBinary           =   128; //  Indicates a binary value (DBTYPE_BYTES).
    adChar             =   129; //  Indicates a string value (DBTYPE_STR).
    adWChar            =   130; //  Indicates a null-terminated Unicode character string (DBTYPE_WSTR).
    adNumeric          =   131; //  Indicates an exact numeric value with a fixed precision and scale (DBTYPE_NUMERIC).
    adUserDefined      =   132; //  Indicates a user-defined variable (DBTYPE_UDT).
    adDBDate           =   133; //  Indicates a date value (yyyymmdd) (DBTYPE_DBDATE).
    adDBTime           =   134; //  Indicates a time value (hhmmss) (DBTYPE_DBTIME).
    adDBTimeStamp      =   135; //  Indicates a date/time stamp (yyyymmddhhmmss plus a fraction in billionths) (DBTYPE_DBTIMESTAMP).
    adChapter          =   136; //  Indicates a four-byte chapter value that identifies rows in a child rowset (DBTYPE_HCHAPTER).
    adPropVariant      =   138; //  Indicates an Automation PROPVARIANT (DBTYPE_PROP_VARIANT).
    adVarNumeric       =   139; //  Indicates a numeric value (Parameter object only).
    adVarChar          =   200; //  Indicates a string value.
    adLongVarChar      =   201; //  Indicates a long string value.
    adVarWChar         =   202; //  Indicates a null-terminated Unicode character string.
    adLongVarWChar     =   203; //  Indicates a long null-terminated Unicode string value.
    adVarBinary        =   204; //  Indicates a binary value (Parameter object only).
    adLongVarBinary    =   205; //  Indicates a long binary value.
    adArray            = $2000; //  A flag value, always combined with another data type constant, that indicates an array of that other data type.

type
    //  ADOڑɂf[^x[XNX
    TDatabase = class(TObject)
    protected
        FCatalog: OleVariant;
        FDatabase: OleVariant;
        FUser: String;
        FPass: String;
        FDatabaseName: String;
        FOpened: Boolean;
    protected
        function BuildConnectionString(const AUser, APass, ADatabaseName: String): String; virtual; abstract; 
    public
        constructor Create();
        destructor Destroy(); override;
        property User: String read FUser;
        property Pass: String read FPass;
        property DatabaseName: String read FDatabaseName;
        property Opened: Boolean read FOpened;
    public
        function Open(const AUser, APass, ADatabaseName: String; var Err: String): Boolean; virtual;
        function ReOpen(var Err: String): Boolean; virtual;
        procedure Close();
        function BeginTrans(var Err: String): Boolean; overload;
        function CommitTrans(var Err: String): Boolean; overload;
        function RollbackTrans(var Err: String): Boolean; overload;
        function BeginTrans(): Boolean; overload;
        function CommitTrans(): Boolean; overload;
        function RollbackTrans(): Boolean; overload;
        function Execute(const AQuery: String; var Err: String): Boolean; overload;
        function Execute(const AQueries: TStrings; var Err: String): Boolean; overload;
    public
        procedure GetTableNames(AList: TStrings);
        procedure GetTableFields(const ATableName: String; AList: TStrings);
        property Catalog: OleVariant read FCatalog;
        property Database: OleVariant read FDatabase;
    public
        function OpenQuery(const AQuery: String; var ASet: OleVariant; var Err: String): Boolean;
        procedure CloseQuery(var ASet: OleVariant);
        procedure MoveNext(const ASet: OleVariant);
        function IsEOF(const ASet: OleVariant): Boolean;
        function IsBOF(const ASet: OleVariant): Boolean;
        function IsXOF(const ASet: OleVariant): Boolean;
        function FieldCount(const ASet: OleVariant): Integer;
        function FieldName(const ASet: OleVariant; const AIndex: Integer): String;
        function FieldValue(const ASet: OleVariant; const AIndex: Integer): Variant; overload;
        function FieldValue(const ASet: OleVariant; const AName: String): Variant; overload;
    end;

    //  JET-DBpf[^x[XNX
    TDatabaseJet = class(TDatabase)
    protected
        function BuildConnectionString(const AUser, APass, ADatabaseName: String): String; override;
        function ColumnTypeIsText(const AColumn: OleVariant): Boolean;
    public
        function Open(const AUser, APass, ADatabaseName: String; var Err: String): Boolean; override;
        function ChangePassword(const ANewPass: String; var Err: String): Boolean;
        function CompactDatabase(var Err: String): Boolean;
        function SyncNullableAllowZeroLength(const ATableName: String; var Err: String): Boolean;
    end;

function Quote(const S: String): String;
function NVL(const V, ADefault: Variant): Variant;

var
    CS: TCriticalSection = nil;
    DB: TDatabase = nil;

implementation

//=============================================================================
//  Utility

//-----------------------------------------------------------------------------
//  dpň͂
function Quote(const S: String): String;
begin
    Result := AnsiQuotedStr(S, '"');
end;

//-----------------------------------------------------------------------------
//  NULL΍
function NVL(const V, ADefault: Variant): Variant;
begin
    Result := V;
    if (VarIsNull(V)) then Result := ADefault;
end;

//-----------------------------------------------------------------------------
//  e|t@C擾
//  http://www.mesuttop.com/delphi/tip_files.htm
function TempFileName(const ADir: String): String;
var
    LBuffer: array[0..MAX_PATH] of Char;
begin
    FillChar(LBuffer, SizeOf(LBuffer), 0);
    GetTempFileName(PChar(ADir), '!mdb', 0, LBuffer);
    Result := String(LBuffer);
end;

//=============================================================================
//  TDatabase

//-----------------------------------------------------------------------------
//  RXgN^
constructor TDatabase.Create();
begin
    inherited Create();
    FCatalog := Unassigned;
    FDatabase := Unassigned;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TDatabase.Destroy();
begin
    Close();
    inherited Destroy();
end;

//-----------------------------------------------------------------------------
//  f[^x[Xɐڑ
function TDatabase.Open(const AUser, APass, ADatabaseName: String; var Err: String): Boolean;
begin
    Close();
    Result := False;
    try
        FCatalog := CreateOleObject('ADOX.Catalog');
        FCatalog.ActiveConnection := BuildConnectionString(AUser, APass, ADatabaseName);
        FDatabase := FCatalog.ActiveConnection;
        FOpened := True;
        FUser := AUser;
        FPass := APass;
        FDatabaseName := ADatabaseName;
        Result := True;
    except
        on E:Exception do
        begin
            Err := E.Message;
            Close();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  čēxJ
function TDatabase.ReOpen(var Err: String): Boolean;
var
    LUser, LPass, LDatabaseName: String;
begin
    LUser := FUser;
    LPass := LPass;
    LDatabaseName := FDatabaseName;

    //  
    Close();

    //  J
    Result := Open(LUser, LPass, LDatabaseName, Err);
end;

//-----------------------------------------------------------------------------
//  f[^x[Xؒf
procedure TDatabase.Close();
begin
    if (FOpened) then
    begin
        FDatabase.Close;
    end;
    FUser := '';
    FPass := '';
    FDatabaseName := '';
    FDatabase := Unassigned;
    FCatalog := Unassigned;
    FOpened := False;
end;

//-----------------------------------------------------------------------------
//  gUNV
function TDatabase.BeginTrans(var Err: String): Boolean;
begin
    Result := False;
    try
        FDatabase.BeginTrans;
        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//-----------------------------------------------------------------------------
function TDatabase.CommitTrans(var Err: String): Boolean;
begin
    Result := False;
    try
        FDatabase.CommitTrans;
        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//-----------------------------------------------------------------------------
function TDatabase.RollbackTrans(var Err: String): Boolean;
begin
    Result := False;
    try
        FDatabase.RollbackTrans;
        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//-----------------------------------------------------------------------------
//  gUNV(G[esv)
function TDatabase.BeginTrans(): Boolean;
var
    LErr: String;
begin
    Result := BeginTrans(LErr);
end;

//-----------------------------------------------------------------------------
function TDatabase.CommitTrans(): Boolean;
var
    LErr: String;
begin
    Result := CommitTrans(LErr);
end;

//-----------------------------------------------------------------------------
function TDatabase.RollbackTrans(): Boolean;
var
    LErr: String;
begin
    Result := RollbackTrans(LErr);
end;

//-----------------------------------------------------------------------------
//  NG[s
function TDatabase.Execute(const AQuery: String; var Err: String): Boolean;
begin
    Result := False;
    try
        FDatabase.Execute(AQuery);
        Result := True;
    except
        on E:Exception do Err := E.Message + ';' + AQuery;
    end;
end;

//-----------------------------------------------------------------------------
//  NG[ꊇs(s)
function TDatabase.Execute(const AQueries: TStrings; var Err: String): Boolean;
var
    i: Integer;
    LQuery: String;
begin
    Result := False;
    for i := 0 to AQueries.Count - 1 do
    begin
        LQuery := AQueries.Strings[i];
        if (LQuery <> '') then
        begin
            Result := Execute(LQuery, Err);
            if (not Result) then Break;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  e[üꗗ擾
procedure TDatabase.GetTableNames(AList: TStrings);
var
    LTables: OleVariant;
    LTable: OleVariant;
    i: Integer;
begin
    LTables := FCatalog.Tables;
    for i := 0 to LTables.Count - 1 do
    begin
        LTable := LTables.Item[i];
        AList.Add(LTable.Name);
    end;
end;

//-----------------------------------------------------------------------------
//  we[ũtB[ḧꗗ擾
procedure TDatabase.GetTableFields(const ATableName: String; AList: TStrings);
var
    LTables: OleVariant;
    LTable: OleVariant;
    LColumns: OleVariant;
    LColumn: OleVariant;
    i: Integer;
begin
    LTables := FCatalog.Tables;
    LTable := LTables.Item[ATableName];
    LColumns := LTable.Columns;
    for i := 0 to LColumns.Count - 1 do
    begin
        LColumn := LColumns.Item[i];
        AList.Add(LColumn.Name);
    end;
end;

//-----------------------------------------------------------------------------
//  R[hZbg쐬
function TDatabase.OpenQuery(const AQuery: String; var ASet: OleVariant; var Err: String): Boolean;
begin
    Result := False;
    ASet := Unassigned;
    try
        ASet := CreateOleObject('ADODB.Recordset');
        ASet.Open(AQuery, FDatabase);
        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//-----------------------------------------------------------------------------
//  R[hZbgj
procedure TDatabase.CloseQuery(var ASet: OleVariant);
begin
    ASet.Close;
    ASet := Unassigned;
end;

//-----------------------------------------------------------------------------
//  ̃R[hֈړ
procedure TDatabase.MoveNext(const ASet: OleVariant);
begin
    ASet.MoveNext;
end;

//-----------------------------------------------------------------------------
//  R[hZbgEOFǂ
function TDatabase.IsEOF(const ASet: OleVariant): Boolean;
begin
    Result := ASet.EOF;
end;

//-----------------------------------------------------------------------------
//  R[hZbgBOFǂ
function TDatabase.IsBOF(const ASet: OleVariant): Boolean;
begin
    Result := ASet.BOF;
end;

//-----------------------------------------------------------------------------
//  R[hZbgEOF܂BOFǂ
function TDatabase.IsXOF(const ASet: OleVariant): Boolean;
begin
    Result := IsEOF(ASet) or IsBOF(ASet);
end;

//-----------------------------------------------------------------------------
//  R[hZbg̃tB[h
function TDatabase.FieldCount(const ASet: OleVariant): Integer;
begin
    Result := ASet.Fields.Count;    
end;

//-----------------------------------------------------------------------------
//  R[hZbg̎wԖڂ̃tB[h
function TDatabase.FieldName(const ASet: OleVariant; const AIndex: Integer): String;
begin
    Result := ASet.Fields[AIndex].Name;
end;

//-----------------------------------------------------------------------------
//  R[hZbg̎wԖڂ̒l
function TDatabase.FieldValue(const ASet: OleVariant; const AIndex: Integer): Variant;
begin
    Result := ASet.Fields[AIndex].Value;
end;

//-----------------------------------------------------------------------------
//  R[hZbg̒l
function TDatabase.FieldValue(const ASet: OleVariant; const AName: String): Variant;
begin
    Result := ASet.Fields[AName].Value;
end;

//=============================================================================
//  TDatabaseJet

//-----------------------------------------------------------------------------
//  ڑ쐬
function TDatabaseJet.BuildConnectionString(const AUser, APass, ADatabaseName: String): String;
const
    JET_OLEDB = 'Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Database Password=%s;Data Source=%s';
begin
    Result := Format(JET_OLEDB, [APass, ADatabaseName]);
end;

//-----------------------------------------------------------------------------
//  f[^x[XJ(Ȃ΍)
//  TDatabase.Open ƂقƂǓȂ̂Ȃ
function TDatabaseJet.Open(const AUser, APass, ADatabaseName: String; var Err: String): Boolean;
begin
    Close();
    Result := False;
    try
        FCatalog := CreateOleObject('ADOX.Catalog');

        //  Ȃ΍
        if (not FileExists(ADatabaseName)) then
        begin
            FCatalog.Create(BuildConnectionString(AUser, APass, ADatabaseName));
        end;

        //  ڑ
        FCatalog.ActiveConnection := BuildConnectionString(AUser, APass, ADatabaseName);
        FDatabase := FCatalog.ActiveConnection;
        FOpened := True;
        FUser := AUser;
        FPass := APass;
        FDatabaseName := ADatabaseName;
        Result := True;
    except
        on E:Exception do
        begin
            Err := E.Message;
            Close();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  pX[hύX
function TDatabaseJet.ChangePassword(const ANewPass: String; var Err: String): Boolean;
var
    LUser, LPass, LDatabaseName: String;
    LEngine: OleVariant;
    LTemp: String;
    LSrc, LDst: String;
begin
    Result := False;

    LUser := FUser;
    LPass := FPass;
    LDatabaseName := FDatabaseName;

    //  
    Close();

    //  ꎞt@C
    LTemp := TempFileName(ExtractFilePath(LDatabaseName));
    DeleteFile(LTemp);

    //  ڑ쐬
    LSrc := BuildConnectionString(LUser, LPass, LDatabaseName);
    LDst := BuildConnectionString(LUser, ANewPass, LTemp);

    try
        try
            //  pX[hύX(mɂ͍œK)
            LEngine := CreateOleObject('JRO.JetEngine');
            LEngine.CompactDatabase(LSrc, LDst);

            //  u
            DeleteFile(LDatabaseName);
            RenameFile(LTemp, LDatabaseName);
        finally
            LEngine := Unassigned;
        end;
        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;

    //  J
    if Result then
    begin
        Result := Open(LUser, ANewPass, LDatabaseName, Err);
    end
    else
    begin
        Result := Open(LUser, LPass, LDatabaseName, Err);
    end;
end;

//-----------------------------------------------------------------------------
//  f[^x[XœK
function TDatabaseJet.CompactDatabase(var Err: String): Boolean;
begin
    Result := ChangePassword(FPass, Err);
end;

//-----------------------------------------------------------------------------
//  IuWFNǧ^^ǂ
function TDatabaseJet.ColumnTypeIsText(const AColumn: OleVariant): Boolean;
var
    LType: Integer;
begin
    LType := AColumn.Type;
    Result := LType in
                [adBSTR, adChar, adWChar, adVarChar,
                 adLongVarChar, adLongVarChar, adVarWChar, adLongVarWChar];
end;

//-----------------------------------------------------------------------------
//  we[u NULL ̃tB[h 󕶎񋖉tO𗧂Ă
function TDatabaseJet.SyncNullableAllowZeroLength(const ATableName: String; var Err: String): Boolean;
var
    LTables: OleVariant;
    LTable: OleVariant;
    LColumns: OleVariant;
    LColumn: OleVariant;
    i: Integer;
begin
    Result := False;

    LTables := FCatalog.Tables;
    LTable := LTables.Item[ATableName];
    LColumns := LTable.Columns;

    try
        for i := 0 to LColumns.Count - 1 do
        begin
            LColumn := LColumns.Item[i];

            //  ^̂ݑΏۂɂ
            if (not ColumnTypeIsText(LColumn)) then Continue;

            //  NULL̂ݑΏۂɂ
            if (not LColumn.Properties['Nullable']) then Continue;

            //  󕶎񋖉ɐݒ肷
            LColumn.Properties['Jet OLEDB:Allow Zero Length'] := True;
        end;

        Result := True;
    except
        on E:Exception do Err := E.Message;
    end;
end;

//-----------------------------------------------------------------------------
initialization
    CS := TCriticalSection.Create();
finalization
    CS.Free();
end.
